program NearStarMap (input, output, infile);

{$M 65520, 0, 655360}
{$N+,E+,D+,L+,G+}

uses BGIDriv, CRT, Graph, Mouse;

type starrec=record
       xx, yy, zz: real;
       name: string[30];
       star: string[10];
       mag: real;
     end;

     starlist=array[1..749] of starrec;

procedure split(var x, y, z, mag: real; var name, star, temp: string);
  var wkstr: string;
      code: integer;
  begin
    wkstr:='';
    while temp[1]<>',' do
      begin
        wkstr:=wkstr+temp[1];
        delete(temp, 1, 1);
      end;
    delete(temp, 1, 1);
    val(wkstr, x, code);
    wkstr:='';
    while temp[1]<>',' do
      begin
        wkstr:=wkstr+temp[1];
        delete(temp, 1, 1);
      end;
    delete(temp, 1, 1);
    val(wkstr, y, code);
    wkstr:='';
    while temp[1]<>',' do
      begin
        wkstr:=wkstr+temp[1];
        delete(temp, 1, 1);
      end;
    delete(temp, 1, 1);
    val(wkstr, z, code);
    wkstr:='';
    while temp[1]<>',' do
      begin
        wkstr:=wkstr+temp[1];
        delete(temp, 1, 1);
      end;
    delete(temp, 1, 1);
    name:=wkstr;
    wkstr:='';
    while temp[1]<>',' do
      begin
        wkstr:=wkstr+temp[1];
        delete(temp, 1, 1);
      end;
    delete(temp, 1, 1);
    star:=wkstr;
    for code:=1 to length(star) do
      star[code]:=upcase(star[code]);
    insert(' ', star, 3);
    wkstr:='';
    while not (temp='') do
      begin
        wkstr:=wkstr+temp[1];
        delete(temp, 1, 1);
      end;
    delete(temp, 1, 1);
    val(wkstr, mag, code);
  end;

var infile: text;
    x, y, z, mag, xv, yv, zv, dist: real;
    drv, mode: integer;
    xp, yp, zp, tx, ty, yd, pd, rd, code, first, second: integer;
    tpage, vpage, wpage: word;
    yaw, pitch, roll: real;
    col, keych: byte;
    sc: char;
    name, star, temp: string;
    sp: ^starlist;
    cs: starrec;
    count, total: word;
    quit: boolean;

begin

  getmem(sp, sizeof(sp));

  if registerbgidriver(@egavgadriverproc)<0 then
    halt;
  drv:=vga;
  mode:=vgamed;
  initgraph(drv, mode, '');
  if graphresult <> grok then
    halt;
  assign(infile, 'nearstar.dat');
  reset(infile);
  count:=0;

  repeat
    inc(count);
    readln(infile, temp);
    split(x, y, z, mag, name, star, temp);
    cs.xx:=x*4;
    cs.yy:=y*4;
    cs.zz:=z*4;
    cs.name:=name;
    cs.star:=star;
    cs.mag:=mag;
    sp^[count]:=cs;
  until eof(infile);
  close(infile);
  total:=count;

  first:=1;
  second:=76;

  if paramstr(1)<>'' then
    val(paramstr(1), first, code);
  if ((first<1) or (first>749)) then
    first:=1;
  if paramstr(2)<>'' then
    val(paramstr(2), second, code);
  if ((second<1) or (second>749)) then
    second:=76;

  yaw:=0;
  pitch:=0;
  roll:=0;

  yd:=1;
  pd:=0;
  rd:=0;

  vpage:=1;
  wpage:=0;
  keych:=$00;

  quit:=false;

  setvisualpage(vpage);
  setactivepage(wpage);

  repeat
    clearviewport;
    for count:=1 to total do
      begin
        x:=sp^[count].xx;
        y:=sp^[count].yy;
        z:=sp^[count].zz;

        zp:=trunc((cos(yaw)*z)-(sin(yaw)*x));
        xp:=trunc((cos(yaw)*x)+(sin(yaw)*z));
        yp:=trunc(y);

        x:=xp;
        y:=yp;
        z:=zp;

        zp:=trunc((cos(pitch)*z)-(sin(pitch)*y));
        xp:=trunc(x);
        yp:=trunc((cos(pitch)*y)+(sin(pitch)*z));

        x:=xp;
        y:=yp;
        z:=zp;

        xp:=trunc((cos(roll)*x)+(sin(roll)*y));
        yp:=trunc((cos(roll)*y)-(sin(roll)*x));

        xp:=trunc(xp*(1+(zp/1024)));
        yp:=trunc(yp*(1+(zp/1024)));


        xp:=xp+220;
        yp:=trunc(yp*0.73)+175;

        case zp of
          -300..-1: col:=lightgray;
          0..300: col:=white;
        end;

        putpixel(xp, yp, col);


        if count=first then
          begin
            case zp of
              -300..-1: col:=cyan;
              0..300: col:=lightcyan;
            end;
            setcolor(col);
            rectangle(xp-3, yp-2, xp+3, yp+2);
            putpixel(xp, yp, col);
          end
        else if count=second then
          begin
            case zp of
              -300..-1: col:=magenta;
              0..300: col:=lightmagenta;
            end;
            setcolor(col);
            rectangle(xp-3, yp-2, xp+3, yp+2);
            putpixel(xp, yp, col);
          end
        else if count=1 then
          begin
            putpixel(xp, yp, yellow);
          end;
      end;

    setcolor(white);
    outtextxy(220, 0, '2300AD Near Star Map v1.0');

    setcolor(lightgray);
    outtextxy(280, 10, 'by W.Young');
    outtextxy(275, 340, 'Esc to quit');
    outtextxy(400, 30, 'X: Increase pitch');
    outtextxy(400, 40, 'Y: Increase yaw');
    outtextxy(400, 50, 'Z: Increase roll');
    outtextxy(400, 60, 'Shift+X/Y/Z: Decrease same');
    str(pd:4, temp);
    outtextxy(600, 30, temp);
    str(yd:4, temp);
    outtextxy(600, 40, temp);
    str(rd:4, temp);
    outtextxy(600, 50, temp);

    outtextxy(440, 175, 'Distance between points:');
    dist:=sqrt( sqr(sp^[first].xx-sp^[second].xx)+
                sqr(sp^[first].yy-sp^[second].yy)+
                sqr(sp^[first].zz-sp^[second].zz) )/4;
    str(dist:5:1, temp);
    outtextxy(480, 185, temp);
    outtextxy(536, 185, 'Light Years');

    temp:=chr(24)+', '+chr(25)+', PgUp, PgDn';
    outtextxy(430, 120, temp);
    temp:=chr(27)+', '+chr(26)+', Home, End';
    outtextxy(430, 240, temp);

    setcolor(cyan);
    outtextxy(400, 80, sp^[first].name);
    outtextxy(420, 90, sp^[first].star);
    outtextxy(440, 100, '#');
    str(first, temp);
    outtextxy(448, 100, temp);
    setcolor(magenta);
    outtextxy(400, 260, sp^[second].name);
    outtextxy(420, 270, sp^[second].star);
    outtextxy(440, 280, '#');
    str(second, temp);
    outtextxy(448, 280, temp);

    tpage:=vpage;
    vpage:=wpage;
    wpage:=tpage;
    setvisualpage(vpage);
    setactivepage(wpage);

    yaw:=yaw+(yd/180)*pi;
    pitch:=pitch+(pd/180)*pi;
    roll:=roll+(rd/180)*pi;

    if yaw>(2*pi) then
      yaw:=yaw-(2*pi)
    else if yaw<0 then
      yaw:=yaw+(2*pi);

    if pitch>(2*pi) then
      pitch:=pitch-(2*pi)
    else if pitch<0 then
      pitch:=pitch+(2*pi);

    if roll>(2*pi) then
      roll:=roll-(2*pi)
    else if roll<0 then
      roll:=roll+(2*pi);

    if ((yd=0) and (pd=0) and (rd=0) and (keypressed=false)) then
      repeat until keypressed;

    if keypressed then
      begin
        keych:=ord(readkey);
        case keych of
          $78: begin
                 inc(pd);
                 if pd>180 then
                   pd:=pd-360
               end;
          $58: begin
                 dec(pd);
                 if pd<-180 then
                   pd:=pd+360
               end;
          $79: begin
                 inc(yd);
                 if yd>180 then
                   yd:=yd-360
               end;
          $59: begin
                 dec(yd);
                 if yd<-180 then
                   yd:=yd+360
               end;
          $7A: begin
                 inc(rd);
                 if rd>180 then
                   rd:=rd-360
               end;
          $5A: begin
                 dec(rd);
                 if rd<-180 then
                   rd:=rd+360
               end;
          $20: begin
                 yaw:=0;
                 pitch:=0;
                 roll:=0;
                 yd:=0;
                 pd:=0;
                 rd:=0;
               end;
          $1B: quit:=true;
          $00: begin
                 if keypressed then
                   keych:=ord(readkey);
                 case keych of
                   $48: begin
                          dec(first);
                          if first<1 then
                            inc(first, 749);
                        end;
                   $50: begin
                          inc(first);
                          if first>749 then
                            dec(first, 749);
                        end;
                   $49: begin
                          dec(first, 10);
                          if first<1 then
                            inc(first, 749);
                        end;
                   $51: begin
                          inc(first, 10);
                          if first>749 then
                            dec(first, 749);
                        end;
                   $4B: begin
                          dec(second);
                          if second<1 then
                            inc(second, 749);
                        end;
                   $4D: begin
                          inc(second);
                          if second>749 then
                            dec(second, 749);
                        end;
                   $47: begin
                          dec(second, 10);
                          if second<1 then
                            inc(second, 749);
                        end;
                   $4F: begin
                          inc(second, 10);
                          if second>749 then
                            dec(second, 749);
                        end;
                   $4C: begin
                          first:=1;
                          second:=76;
                        end;
                 end;
               end;
        end;

      end;
  until quit;
  closegraph;
  freemem(sp, sizeof(sp));
  textmode(co80);
  clrscr;
end.
